#include "gplbp.h"

void drawactivity(struct CurrentEntries *curr)
{
	GtkWidget *entry;
	GtkWidget *label;
	GtkWidget *peachbox;
	GtkWidget *button;
	GtkWidget *table2;
	GtkWidget *frame;
	GtkWidget *htextbox;
	GtkWidget *vscrollbar;
	GtkObject *hadj;
	GtkObject *vadj;
	GtkWidget *littlebox;
	GtkWidget *dualtable;
	GtkWidget *cb;
	GList *cbitems = NULL;

	time_t timestruct = time(NULL);
	struct tm *tmstruct;
	gchar timestring[DTMAX];


/* Get the users carp from the rc file. */
        if (editing == 0)
        {
                parse_rc(curr);
        }

/* Set up the activity table */
	activitytable = gtk_table_new(16, 16, FALSE);

/* Set up (and attach) all of the buttons */

	label = gtk_label_new("");
	gtk_table_attach(GTK_TABLE(activitytable), label, 1, 2, 2, 3, 0, 0, 5, 4);
	gtk_widget_show(label);

	label = gtk_label_new("");
	gtk_table_attach(GTK_TABLE(activitytable), label, 1, 2, 8, 9, 0, 0, 5, 4);
	gtk_widget_show(label);
	
	label = gtk_label_new("");
	gtk_table_attach(GTK_TABLE(activitytable), label, 1, 2, 11, 12, 0, 0, 5, 4);
	gtk_widget_show(label);

/* Set the date to todays date. */

	tmstruct = localtime(&timestruct);
	snprintf(timestring, DTMAX, "%i/%i/%i", tmstruct->tm_mon + 1, tmstruct->tm_mday, tmstruct->tm_year + 1900);
	
	entry = gtk_entry_new_with_max_length(DTMAX);
	if (strlen(curr->Date) == 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), timestring);
		strncpy(curr->Date, timestring, DTMAX);
	}
	else
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Date);
	}
	gtk_table_attach(GTK_TABLE(activitytable), entry, 1, 2, 1, 2, 0, 0, 1, 1);
	gtk_widget_set_usize(entry, 75, 20);
	label = gtk_label_new("Date");
	gtk_table_attach(GTK_TABLE(activitytable), label, 1, 2, 0, 1, 0, 0, 1, 1);
	gtk_widget_show(entry);
	gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(datechanged), curr);

	entry = gtk_entry_new_with_max_length(TNMAX - 1);
	if (strlen(curr->TailNumber) == 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), DEFAULTTAILNUMBER);
		strncpy(curr->TailNumber, DEFAULTTAILNUMBER, TNMAX);
	}
	else
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->TailNumber);
	}
	gtk_table_attach(GTK_TABLE(activitytable), entry, 3, 4, 1, 2, 0, 0, 1, 1);
	gtk_widget_set_usize(entry, 75, 20);
	label = gtk_label_new("Tail Number");
	gtk_table_attach(GTK_TABLE(activitytable), label, 3, 4, 0, 1, 0, 0, 1, 1);
	gtk_widget_show(entry);
	gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(tailchanged), curr);

	entry = gtk_entry_new_with_max_length(MMMAX);
	if (strlen(curr->MakeModel) == 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), "Cessna 172");
		strncpy(curr->MakeModel, "Cessna 172", MMMAX);
	}
	else
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->MakeModel);
	}
	gtk_table_attach(GTK_TABLE(activitytable), entry, 5, 6, 1, 2, 0, 0, 1, 1);
	gtk_widget_set_usize(entry, 100, 20);
	label = gtk_label_new("Make/Model");
	gtk_table_attach(GTK_TABLE(activitytable), label, 5, 6, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(entry);
        gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(makemodelchanged), curr);
	
        entry = gtk_entry_new_with_max_length(FRMAX);
	if (strlen(curr->From) == 0)
	{
	        gtk_entry_set_text(GTK_ENTRY(entry), "SLC");
		strncpy(curr->From, "SLC", FRMAX);
	}
	else
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->From);
	}
        gtk_table_attach(GTK_TABLE(activitytable), entry, 7, 8, 1, 2, 0, 0, 1, 1);
        gtk_widget_set_usize(entry, 130, 20);
        label = gtk_label_new("From (Route)");
        gtk_table_attach(GTK_TABLE(activitytable), label, 7, 8, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(entry);
        gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(fromchanged), curr);

        entry = gtk_entry_new_with_max_length(TOMAX);
	if (strlen(curr->To) == 0)
	{
        	gtk_entry_set_text(GTK_ENTRY(entry), "local");
	}
	else
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->To);
	}
        gtk_table_attach(GTK_TABLE(activitytable), entry, 9, 10, 1, 2, 0, 0, 1, 1);
        gtk_widget_set_usize(entry, 130, 20);
        label = gtk_label_new("To");
        gtk_table_attach(GTK_TABLE(activitytable), label, 9, 10, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(entry);
        gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(tochanged), curr);
	strncpy(curr->To, "local", TOMAX);

        entry = gtk_entry_new_with_max_length(TDMAX);
	if (strlen(curr->TotalDur) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->TotalDur);
	}
        gtk_table_attach(GTK_TABLE(activitytable), entry, 11, 12, 1, 2, 0, 0, 1, 1);
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Total Dur");
        gtk_table_attach(GTK_TABLE(activitytable), label, 11, 12, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(entry);
        gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(totaldurchanged), curr);

        entry = gtk_entry_new_with_max_length(AIMAX);
	if (strlen(curr->ActInst) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->ActInst);
	}
        gtk_table_attach(GTK_TABLE(activitytable), entry, 13, 14, 1, 2, 0, 0, 1, 1);
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Act Inst");
        gtk_table_attach(GTK_TABLE(activitytable), label, 13, 14, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(entry);
        gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(actinstchanged), curr);

        entry = gtk_entry_new_with_max_length(SIMAX);
	if (strlen(curr->SimInst) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->SimInst);
	}
        gtk_table_attach(GTK_TABLE(activitytable), entry, 15, 16, 1, 2, 0, 0, 1, 1);
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Sim Inst");
        gtk_table_attach(GTK_TABLE(activitytable), label, 15, 16, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(entry);
        gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(siminstchanged), curr);

	entry = gtk_entry_new_with_max_length(APPSMAX);
	if (strlen(curr->Apps) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->SimInst);
	}
        gtk_table_attach(GTK_TABLE(activitytable), entry, 1, 2, 6, 7, 0, 0, 1, 1);
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("# Apps");
        gtk_table_attach(GTK_TABLE(activitytable), label, 1, 2, 5, 6, 0, 0, 1, 1);
        gtk_widget_show(entry);
        gtk_widget_show(label);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(appschanged), curr);

/* Start the First combo Box */

	cb = gtk_combo_new();

	cbitems = g_list_append(cbitems, "VFR");
	cbitems = g_list_append(cbitems, "VOR");
	cbitems = g_list_append(cbitems, "ILS");
	cbitems = g_list_append(cbitems, "NDB");
	gtk_combo_set_popdown_strings(GTK_COMBO(cb), cbitems);
	if (strlen(curr->TypeOfApproaches) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cb)->entry), curr->TypeOfApproaches);
	}
	else
	{
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cb)->entry), "VFR");
		strncpy(curr->TypeOfApproaches, "VFR", TOAMAX);
	}
        gtk_widget_set_usize(cb, 100, 20);
	gtk_widget_set_usize(GTK_COMBO(cb)->entry, 100, 20);
        label = gtk_label_new("Type of Approches");
        gtk_widget_show(cb);
        gtk_widget_show(label);
	peachbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(peachbox), cb, FALSE, FALSE, 0);
	button = gtk_button_new_with_label("E");
	gtk_widget_set_usize(button, 15, 20);
	gtk_widget_show(button);
	gtk_box_pack_start(GTK_BOX(peachbox), button, FALSE, FALSE, 2);
	gtk_table_attach(GTK_TABLE(activitytable), peachbox, 3, 4, 6, 7, 0, 0, 1, 1);
	gtk_table_attach(GTK_TABLE(activitytable), label, 3, 4, 5, 6, 0, 0, 1, 1);
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(cb)->entry), "changed", GTK_SIGNAL_FUNC(typeofapproachchanged), curr);

	table2 = gtk_table_new(5, 2, FALSE);
	
	entry = gtk_entry_new_with_max_length(DAYMAX - 1 );
	if (strlen(curr->Day) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Day);
	}
	gtk_widget_set_usize(entry, 50, 20);
	label = gtk_label_new("Day");
	gtk_widget_show(entry);
	gtk_widget_show(label);
	gtk_table_attach(GTK_TABLE(table2), entry, 0, 1, 1, 2, 0, 0, 1, 1);
	gtk_table_attach(GTK_TABLE(table2), label, 0, 1, 0, 1, 0, 0, 1, 1);
	gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(daychanged), curr);

	entry = gtk_entry_new_with_max_length(NIGHTMAX - 1);
	if (strlen(curr->Night) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Night);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Night");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 1, 2, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 1, 2, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(nightchanged), curr);

	entry = gtk_entry_new_with_max_length(DLMAX - 1);
	if (strlen(curr->DayLdgs) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->DayLdgs);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Day Ldgs");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 2, 3, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 2, 3, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(dayldgschanged), curr);

	entry = gtk_entry_new_with_max_length(NLMAX - 1);
	if (strlen(curr->NightLdgs) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->NightLdgs);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Night Ldgs");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 3, 4, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 3, 4, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(nightldgschanged), curr);


	entry = gtk_entry_new_with_max_length(XCMAX - 1);
	if (strlen(curr->XC) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->XC);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("X/C");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 5, 6, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 5, 6, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(xcchanged), curr);

	entry = gtk_entry_new_with_max_length(PICMAX - 1);
	if (strlen(curr->PIC) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->PIC);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("PIC");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 6, 7, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 6, 7, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(picchanged), curr);
	
	entry = gtk_entry_new_with_max_length(SICMAX - 1);
	if (strlen(curr->SIC) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->SIC);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("SIC");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 7, 8, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 7, 8, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(sicchanged), curr);

	entry = gtk_entry_new_with_max_length(P135MAX - 1);
	if (strlen(curr->Part135) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Part135);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Part 135");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 8, 9, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 8, 9, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(part135changed), curr);

	entry = gtk_entry_new_with_max_length(P121MAX - 1);
	if (strlen(curr->Part121) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Part121);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Part 121");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 9, 10, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 9, 10, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(part121changed), curr);

	entry = gtk_entry_new_with_max_length(MILMAX - 1);
	if (strlen(curr->Mil) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Mil);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Mil");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 10, 11, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 10, 11, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(milchanged), curr);
	
	frame = gtk_frame_new("Definable Flight Conditions");
	gtk_container_add(GTK_CONTAINER(frame), table2);
	gtk_table_attach(GTK_TABLE(activitytable), frame, 5, 16, 5, 7, 0, 0, 0, 0);
	gtk_widget_show(frame);

/*Start Next Table */
        table2 = gtk_table_new(5, 2, FALSE);

        entry = gtk_entry_new_with_max_length(ASELMAX - 1);
	if (strlen(curr->ASEL) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->ASEL);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("ASEL");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 0, 1, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 0, 1, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(aselchanged), curr);

	entry = gtk_entry_new_with_max_length(AMELMAX - 1);
	if (strlen(curr->AMEL) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->AMEL);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("AMEL");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 1, 2, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 1, 2, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(amelchanged), curr);

        entry = gtk_entry_new_with_max_length(HPMAX - 1);
	if (strlen(curr->HighPerf) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->HighPerf);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("High Perf");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 2, 3, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 2, 3, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(highperfchanged), curr);

        entry = gtk_entry_new_with_max_length(RETMAX - 1);
	if (strlen(curr->Retract) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Retract);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Retract");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 3, 4, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 3, 4, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(retractchanged), curr);

        entry = gtk_entry_new_with_max_length(JETMAX - 1);
	if (strlen(curr->Jet) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Jet);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Jet");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 5, 6, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 5, 6, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(jetchanged), curr);

        entry = gtk_entry_new_with_max_length(TPMAX - 1);
	if (strlen(curr->TProp) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->TProp);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("T. Prop");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 6, 7, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 6, 7, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(tpropchanged), curr);

        entry = gtk_entry_new_with_max_length(SIMMAX - 1);
	if (strlen(curr->Sim) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Sim);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Sim");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 7, 8, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 7, 8, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(simchanged), curr);

        entry = gtk_entry_new_with_max_length(HELOMAX - 1);
	if (strlen(curr->Helo) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Helo);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Helo");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 8, 9, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 8, 9, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(helochanged), curr);

        entry = gtk_entry_new_with_max_length(GLIMAX - 1);
	if (strlen(curr->Glider) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->Glider);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Glider");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 9, 10, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 9, 10, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(gliderchanged), curr);

        entry = gtk_entry_new_with_max_length(TWMAX - 1);
	if (strlen(curr->TailWheel) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->TailWheel);
	}
        gtk_widget_set_usize(entry, 50, 20);
        label = gtk_label_new("Tail Wheel");
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_widget_show(entry);
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(table2), entry, 10, 11, 1, 2, 0, 0, 1, 1);
        gtk_table_attach(GTK_TABLE(table2), label, 10, 11, 0, 1, 0, 0, 1, 1);
        gtk_widget_show(table2);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(tailwheelchanged), curr);

        frame = gtk_frame_new("Definable Category and Class");
        gtk_container_add(GTK_CONTAINER(frame), table2);
        gtk_table_attach(GTK_TABLE(activitytable), frame, 5, 16, 9, 11, 0, 0, 0, 0);
        gtk_widget_show(frame);

/* Little box for the little goober in the lower left */

	littlebox = gtk_table_new(2, 2, FALSE );
	label = gtk_label_new("User1");
	gtk_widget_show(label);
	gtk_table_attach(GTK_TABLE(littlebox), label, 0, 1, 0, 1, 0, 0, 1, 1);
	entry = gtk_entry_new_with_max_length(U1MAX - 1);
	if (strlen(curr->User1) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->User1);
	}
	gtk_widget_show(entry);
	gtk_widget_set_usize(entry, 50, 20);
	gtk_table_attach(GTK_TABLE(littlebox), entry, 0, 1, 1, 2, 0, 0, 1, 1);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(user1changed), curr);
	
	label = gtk_label_new("User2");
	gtk_widget_show(label);
	gtk_table_attach(GTK_TABLE(littlebox), label, 1, 2, 0, 1, 0, 0, 1, 1);
	entry = gtk_entry_new_with_max_length(U2MAX - 1);
	if (strlen(curr->User2) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->User2);
	}
	gtk_widget_set_usize(entry, 50, 20);
	gtk_widget_show(entry);
	gtk_table_attach(GTK_TABLE(littlebox), entry, 1, 2, 1, 2, 0, 0, 1, 1);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(user2changed), curr);
	
	gtk_widget_show(littlebox);

	frame = gtk_frame_new("User Fields");
	gtk_widget_show(frame);
	gtk_container_add(GTK_CONTAINER(frame), littlebox);
	gtk_table_attach(GTK_TABLE(activitytable), frame, 3, 5, 9, 11, 0, 0, 0, 0);

/* End little goober table */


	dualtable = gtk_table_new(2, 2, FALSE);
	label = gtk_label_new("Dual Rec");
	gtk_widget_show(label);
	gtk_table_attach(GTK_TABLE(dualtable), label, 0, 1, 0, 1, 0, 0, 1, 1);
	entry = gtk_entry_new_with_max_length(DRMAX - 1);
	if (strlen(curr->DualRec) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->DualRec);
	}
	gtk_widget_show(entry);
	gtk_widget_set_usize(entry, 50, 20);
        gtk_table_attach(GTK_TABLE(dualtable), entry, 0, 1, 1, 2, 0, 0, 1, 1);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(dualrecchanged), curr);


	label = gtk_label_new("Dual Giv");
        gtk_widget_show(label);
        gtk_table_attach(GTK_TABLE(dualtable), label, 1, 2, 0, 1, 0, 0, 1, 1);
        entry = gtk_entry_new_with_max_length(DGMAX - 1);

	if (strlen(curr->DualGiv) != 0)
	{
		gtk_entry_set_text(GTK_ENTRY(entry), curr->DualGiv);
	}
 
        gtk_widget_set_usize(entry, 50, 20);
        gtk_widget_show(entry);
        gtk_table_attach(GTK_TABLE(dualtable), entry, 1, 2, 1, 2, 0, 0, 1, 1);
	gtk_signal_connect(GTK_OBJECT(entry), "changed", GTK_SIGNAL_FUNC(dualgivchanged), curr);

	frame = gtk_frame_new("Dual Instruction");
	gtk_container_add(GTK_CONTAINER(frame), dualtable);
	gtk_widget_show(dualtable);	
	gtk_widget_show(frame);
	gtk_table_attach(GTK_TABLE(activitytable), frame, 1, 2, 9, 11, 0, 0, 0, 0);

/* Put a box for the user to enter remarks/endorsements/whatever. */
	if (textwindow != NULL)
	{
		gtk_widget_destroy(textwindow);
	}
	textwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(textwindow), "Remarks and Endorsements");

	htextbox = gtk_hbox_new(FALSE, 0);
	hadj = gtk_adjustment_new(0, 0, 50, 1, 30, 50);
	vadj = gtk_adjustment_new(0, 0, 50, 1, 10, 50);
	text = gtk_text_new(GTK_ADJUSTMENT(hadj), GTK_ADJUSTMENT(vadj));
	gtk_text_set_editable(GTK_TEXT(text), TRUE);

	gtk_widget_set_usize(text, 200, 300);
	vscrollbar = gtk_vscrollbar_new(GTK_ADJUSTMENT(vadj)); 
	gtk_signal_connect(GTK_OBJECT(text), "changed", GTK_SIGNAL_FUNC(boxchanged), curr);
	

        gtk_box_pack_start(GTK_BOX(htextbox), text, FALSE, TRUE, 0);
        gtk_box_pack_start(GTK_BOX(htextbox), vscrollbar, FALSE, FALSE, 0);

	gtk_container_add(GTK_CONTAINER(textwindow), htextbox);
	gtk_widget_realize(text);
	if (strlen(curr->RemarksAndEndorsements) != 0)
 	{
		gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, curr->RemarksAndEndorsements, -1);
	}
 
	gtk_widget_show(vscrollbar); 
        gtk_widget_show(text);
        gtk_widget_show(htextbox);
	gtk_widget_show(textwindow);

	
/*	gtk_table_attach(GTK_TABLE(activitytable), htextbox, 0, 16, 14, 16, 0, 0, 1, 1);*/

	gtk_container_add(GTK_CONTAINER(activitybox), activitytable);
	gtk_widget_show(peachbox);
	gtk_widget_show(activitytable);
}



