#include "gplbp.h"

/* Function to delete a record from the data file. */

void deleterecord(GtkWidget *widget, struct CurrentEntries *curr)
{
	
	FILE *tempfile;
	char *tempname;
	u_int32_t bytes;
	GtkWidget *vbox;
	GtkWidget *button;
	GtkWidget *label;

	if (clistrow < 0)
	{
		dialogwindow = gtk_window_new(GTK_WINDOW_DIALOG);
        	gtk_window_position(GTK_WINDOW(dialogwindow), GTK_WIN_POS_MOUSE);
        	vbox = gtk_vbox_new(FALSE, 0);

       		label = gtk_label_new("You have not selected\nan item for deletion.");
        	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);

        	button = gtk_button_new_with_label("OK");
        	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(closedialog), NULL);
        	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);

        	gtk_container_add(GTK_CONTAINER(dialogwindow), vbox);
        	gtk_container_border_width(GTK_CONTAINER(dialogwindow), 5);
       		gtk_widget_show(label);
        	gtk_widget_show(button);
        	gtk_widget_show(vbox);
        	gtk_widget_show(dialogwindow);
	}
	else
	{
	tempname = tempnam(NULL, ".gplbp");
	#ifdef DEBUG
		g_print("Opening %s as a temporary file.\n", tempname);
		fflush(stdout);
	#endif
	
	tempfile = fopen (tempname, "w+");
	if (tempfile == NULL)
	{
		GtkWidget *window;
		GtkWidget *label;
		char errormessage[128];
		
		snprintf(errormessage, 127, "Could not open\n%s\nas a temporary file.", tempname);
	
		window = gtk_window_new(GTK_WINDOW_DIALOG);
		gtk_window_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
		label = gtk_label_new(errormessage);
		
		gtk_container_add(GTK_CONTAINER(window), label);
		gtk_container_border_width(GTK_CONTAINER(window), 10);
		
		gtk_widget_show(label);
		gtk_widget_show(window);
	}
	else 
	{
		int c;
		struct CurrentEntries *tempcurr;

		tempcurr = malloc(sizeof(struct CurrentEntries));
		if (tempcurr == NULL)
		{
			fprintf(stderr, "Malloc failed.  Out of memory?\n");
			exit(254);
		}
		#ifdef DEBUG
			g_print ("Just alloc'd %i bytes of memory.\n", sizeof(struct CurrentEntries));
			fflush(stdout);
		#endif
		fseek(datafile, 0, SEEK_SET);
		for(c = 1; c <= clistrow; c++)
		{
			fread(tempcurr, sizeof(struct CurrentEntries), 1, datafile);
			fwrite(tempcurr, sizeof(struct CurrentEntries), 1, tempfile);
		}
		fseek(datafile, sizeof(struct CurrentEntries), SEEK_CUR);

		bytes = fread(tempcurr, sizeof(struct CurrentEntries), 1, datafile);
		while (bytes != 0)
		{
			fwrite(tempcurr, sizeof(struct CurrentEntries), 1, tempfile);
			bytes = fread(tempcurr, sizeof(struct CurrentEntries), 1, datafile);
		}
		sync();
		fclose(tempfile);  /* Close and reopen the tempfile, to ensure that buggy OS's realize that they need to sync() */
		tempfile = fopen(tempname, "r+");
		fclose(datafile);
		datafile = fopen(lbpfilename, "w+");
		
		if (datafile == NULL)
       		{
               		GtkWidget *window;
               		GtkWidget *label;
                	char errormessage[128];

                	snprintf(errormessage, 127, "Could not open\n%s\nfor writing.", lbpfilename);

                	window = gtk_window_new(GTK_WINDOW_DIALOG);
                	gtk_window_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
                	label = gtk_label_new(errormessage);

                	gtk_container_add(GTK_CONTAINER(window), label);
                	gtk_container_border_width(GTK_CONTAINER(window), 10);

               		gtk_widget_show(label);
                	gtk_widget_show(window);
		}
		else
		{
			bytes = fread(tempcurr, sizeof(struct CurrentEntries), 1, tempfile);
			while (bytes != 0)
			{
				g_print ("In the loop.\n");
				fflush(stdout);
				fwrite(tempcurr, sizeof(struct CurrentEntries), 1, datafile);
				bytes = fread(tempcurr, sizeof(struct CurrentEntries), 1, tempfile);
			}
		}
		fclose(tempfile);
		unlink(tempname);
		free(tempcurr);
	        #ifdef DEBUG
       	       		g_print ("Just freed %i bytes of memory.\n", sizeof(struct CurrentEntries));
       	       		fflush(stdout);
       		#endif
		resetbutton(NULL, curr);
		viewlogbook(NULL, curr);

	}
	}
}
