#include "gplbp.h"

void draw_and_set_up_signals(struct CurrentEntries *curr)
{

	GtkWidget *mainwindow;
	GtkWidget *mainvbox;
	GtkWidget *button;
	GtkWidget *buttonbox;
	GtkWidget *sep;
	GtkWidget *dummybox1;
	GtkWidget *dummybox2;	
	GtkWidget *buttonbox2;	
	GtkTooltips *tooltips;
	GtkWidget *infobox;	

	gchar xpmfile[136];
	gchar prefix[128];
	gchar buffer[128];
	
/* Figure out where the .xpm's are going to end up */

	strncpy(prefix, DATADIR, 118);
	strcat(prefix, "/gplbp/");

/* Set up the main window .. this is where everything will take place */
	mainwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	snprintf(buffer, 128, "%s %s", TITLE, VERSION);
	gtk_window_set_title(GTK_WINDOW(mainwindow), buffer);	

/* Set up the main vertical box, to hold the menu, and the activity table */
	mainvbox = gtk_vbox_new(FALSE, 0);

/* Set up the activity table */
	activitybox = gtk_hbox_new(FALSE, 0);

/* Call the "set up the menus" function.  It's a separate function because it's soo messy.
   This function also packs the menu into the box for us.  We pass everything as parameters
   in case we want to use them later on. */
	drawmenu(mainvbox, curr);

/* Set up the button bar */

	dummybox1 = gtk_hbox_new(FALSE, 0); /* we need dummy boxes so that the button bar doesn't fill the whole screen);*/
	dummybox2 = gtk_hbox_new(FALSE, 0);	
	gtk_widget_set_usize(dummybox1, 80, 30);
	
	gtk_widget_realize(mainwindow);
	buttonbox = gtk_hbox_new(TRUE, 0);
	gtk_box_set_spacing(GTK_BOX(buttonbox), 0);


	#ifdef DEBUG
		g_print("Looking in %s for the pixmaps.\n", prefix);
		fflush(stdout);
	#endif

	snprintf(xpmfile, 136, "%s%s", prefix, "filenew.xpm");
	button = draw_button_bar(buttonbox, mainwindow, xpmfile);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(resetbutton), curr);
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	snprintf(xpmfile, 136, "%s%s", prefix, "fileopen.xpm");
	button = draw_button_bar(buttonbox, mainwindow, xpmfile);
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	snprintf(xpmfile, 136, "%s%s", prefix, "fileprint.xpm");
	button = draw_button_bar(buttonbox, mainwindow, xpmfile);
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	snprintf(xpmfile, 136, "%s%s", prefix, "editcut.xpm");
	button = draw_button_bar(buttonbox, mainwindow, xpmfile);
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	snprintf(xpmfile, 136, "%s%s", prefix, "editcopy.xpm");
	button = draw_button_bar(buttonbox, mainwindow, xpmfile);
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	snprintf(xpmfile, 136, "%s%s", prefix, "editpaste.xpm");
	button = draw_button_bar(buttonbox, mainwindow, xpmfile);
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);

	gtk_box_pack_start(GTK_BOX(dummybox1), buttonbox, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(dummybox1), dummybox2, TRUE, TRUE, 0);
	gtk_widget_show(dummybox1);
	gtk_widget_show(dummybox2);
/* Separator for the button bar. */
	sep = gtk_hseparator_new();

/* Set up the activity table */
	drawactivity(curr);


/* A box for the Save et al . buttons */
	buttonbox2 = gtk_hbox_new(FALSE, 2);

        tooltips = gtk_tooltips_new();
        button = gtk_button_new_with_label("New");
        gtk_box_pack_start(GTK_BOX(buttonbox2), button, FALSE, FALSE, 0);
        gtk_widget_show(button);
        gtk_tooltips_set_tip(tooltips, button, "Reset the current data", NULL);
        gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(resetbutton), curr);

	button = gtk_button_new_with_label("Save");
	gtk_box_pack_start(GTK_BOX(buttonbox2), button, FALSE, FALSE, 0);
	gtk_widget_show(button);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(savebutton), curr);
	gtk_tooltips_set_tip(tooltips, button, "Save the current data", NULL);

	tooltips = gtk_tooltips_new();
	button = gtk_button_new_with_label("View Totals");
        gtk_box_pack_start(GTK_BOX(buttonbox2), button, FALSE, FALSE, 0);
        gtk_widget_show(button);
	gtk_tooltips_set_tip(tooltips, button, "View the totals", NULL);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(viewtotals), curr);

	tooltips = gtk_tooltips_new();	
	button = gtk_button_new_with_label("Medical Info");
        gtk_box_pack_start(GTK_BOX(buttonbox2), button, FALSE, FALSE, 0);
        gtk_widget_show(button);
	gtk_tooltips_set_tip(tooltips, button, "View the medical information", NULL);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(medicalinfo), curr);

	tooltips = gtk_tooltips_new();
	button = gtk_button_new_with_label("View Entire LogBook");
	gtk_box_pack_start(GTK_BOX(buttonbox2), button, FALSE, FALSE, 0);
	gtk_widget_show(button);
	gtk_tooltips_set_tip(tooltips, button, "View all of the entries in your logbook", NULL);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(viewlogbook), curr);
	
	tooltips = gtk_tooltips_new();
	button = gtk_button_new_with_label("Preferences");
	gtk_box_pack_start(GTK_BOX(buttonbox2), button, FALSE, FALSE, 0);
	gtk_widget_show(button);
	gtk_tooltips_set_tip(tooltips, button, "Edit the default entries", NULL);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(change_preferences), curr);

	infolabel = gtk_label_new("Save OK.\n");
	gtk_widget_set_usize(infolabel, 60, 13);
	infobox = gtk_hbox_new(TRUE, 0);
	gtk_widget_set_usize(infobox, 60, 13);
	gtk_box_pack_start(GTK_BOX(infobox), infolabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(buttonbox2), infobox, TRUE, TRUE, 0);
	gtk_widget_show(infobox);

	tooltips = gtk_tooltips_new();
	button = gtk_button_new_with_label("Exit");
	gtk_box_pack_start(GTK_BOX(buttonbox2), button, FALSE, FALSE, 0);
	gtk_widget_show(button);
	gtk_tooltips_set_tip(tooltips, button, "Exit the program", NULL);
        gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(destroy), curr);
	
	gtk_widget_show(buttonbox2);

/* Let the signal connecting commence! */
	gtk_signal_connect(GTK_OBJECT(mainwindow), "delete_event", GTK_SIGNAL_FUNC(delete_event), curr);

/* Pack the button bar into the main vbox */
        gtk_box_pack_start(GTK_BOX(mainvbox), dummybox1, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainvbox), sep, FALSE, TRUE, 0);
	gtk_widget_show(sep);

/* Pack the activity table into the main vbox */
	gtk_box_pack_start(GTK_BOX(mainvbox), activitybox, TRUE, TRUE, 5);

/* Pack the bottom buttons into the main vbox */
	gtk_box_pack_start(GTK_BOX(mainvbox), buttonbox2, FALSE, FALSE, 0);


/* Pack the main vertical box into the main window */
	gtk_container_add(GTK_CONTAINER(mainwindow), mainvbox);
	gtk_container_border_width(GTK_CONTAINER(mainwindow), 5);

/* Show all of the widgets, minus the menu */

	gtk_widget_show(sep);	
	gtk_widget_show(activitytable);
	gtk_widget_show(activitybox);
	gtk_widget_show(buttonbox);
	gtk_widget_show(mainvbox);
	gtk_widget_show(mainwindow); /* Show this one last */

}



