#include "gplbp.h"

void prompt_for_file(struct CurrentEntries *curr)
{

	gchar filepathname[128];
	filesel = gtk_file_selection_new("Create/Open a GPLBP data file.");
	
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filesel)->ok_button), "clicked", GTK_SIGNAL_FUNC(file_ok_clicked), curr);
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filesel)->cancel_button), "clicked", GTK_SIGNAL_FUNC(destroy), curr);

	snprintf(filepathname, 127, "%s%s", getenv("HOME"), "/gplbp.data");
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(filesel), filepathname);

	gtk_widget_show(filesel);

}

void file_ok_clicked(GtkWidget *widget, struct CurrentEntries *curr)
{
	gchar *filename;
	filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(filesel));
	strncpy(lbpfilename, filename, 128);
	gtk_widget_destroy(filesel);

	snprintf(lbpfilename, 127, "%s%s", getenv("HOME"), "/gplbp.data");

        #ifdef DEBUG
                g_print("Just read %s from the file selection box.\n", lbpfilename);
                fflush(stdout);
        #endif


	datafile = fopen(lbpfilename, "r+");
        if (datafile == NULL)
        {
		datafile = fopen(lbpfilename, "w+");
		if (datafile == NULL)
		{
                	fprintf(stderr, "Open of %s failed.\n", lbpfilename);
                	exit(254);
		}
        }
        #ifdef DEBUG
                g_print("Just opened %s.\n", lbpfilename);
                fflush(stdout);
        #endif
	
	draw_and_set_up_signals(curr);
}
