#include <gtk/gtk.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#define TITLE "GNU Pilot LogBook Pro"
#define VERSION "0.92" /* Zero point Niner Two */
#define DEFAULTTAILNUMBER "N96575"

#define DTMAX 11
#define TNMAX 8
#define MMMAX 25
#define FRMAX 25
#define TOMAX 25
#define TDMAX 7
#define AIMAX 6
#define SIMAX 6
#define APPSMAX 5
#define TOAMAX 20
#define DAYMAX 5
#define NIGHTMAX 5
#define DLMAX 5
#define NLMAX 5
#define XCMAX 5
#define PICMAX 5
#define SICMAX 5
#define P135MAX 5
#define P121MAX 5
#define MILMAX 5
#define ASELMAX 5
#define AMELMAX 5
#define HPMAX 5
#define RETMAX 5
#define JETMAX 5
#define TPMAX 5
#define SIMMAX 5
#define HELOMAX 5
#define GLIMAX 5
#define TWMAX 5
#define U2MAX 9
#define U1MAX 9
#define DGMAX 5
#define DRMAX 5
#define RAEMAX 1024

GtkWidget *text;  /* Make this a global variable so that we may access it anywhere, because the gtk
		   * text widget does not have any signals 
		   */
GtkWidget *textwindow; /* Global var so that we may unmap it from anywhere */

GtkWidget *newwindow; 
		  /* Global var here so that we may unmap it from anywhere */

GtkWidget *logbookwindow;

GtkWidget *dialogwindow;

GtkWidget *prefwindow;

GtkWidget *splashwindow;

GtkWidget *clist;

gint32 clistrow;
gint32 clistrow1;
gint32 editing;
gint32 rcfileexists;

GtkWidget *activitytable;
		/* This one's also global so we can destroy it from anywhere */

GtkWidget *activitybox;

GtkWidget *infolabel;
		/* A label for giving the user information */

FILE *datafile;
		/* Global for global access */

gint32 saved;  
		/* Global variable to see if we've saved the current data */

gchar lbpfilename[128];

GtkWidget *filesel;

struct CurrentEntries {
        char Date[DTMAX];
        char TailNumber[TNMAX];
        char MakeModel[MMMAX];
        char From[FRMAX];
        char To[TOMAX];
        char TotalDur[TDMAX];
        char ActInst[AIMAX];
        char SimInst[SIMAX];
        char Apps[APPSMAX];
        char TypeOfApproaches[TOAMAX];
        char Day[DAYMAX];
        char Night[NIGHTMAX];
        char DayLdgs[DLMAX];
        char NightLdgs[NLMAX];
        char XC[XCMAX];
        char PIC[PICMAX];
        char SIC[SICMAX];
        char Part135[P135MAX];
        char Part121[P121MAX];
        char Mil[MILMAX];
        char DualRec[DRMAX];
        char DualGiv[DGMAX];
        char User1[U1MAX];
        char User2[U2MAX];
        char ASEL[ASELMAX];
        char AMEL[AMELMAX];
        char HighPerf[HPMAX];
        char Retract[RETMAX];
        char Jet[JETMAX];
        char TProp[TPMAX];
        char Sim[SIMMAX];
        char Helo[HELOMAX];
        char Glider[GLIMAX];
        char TailWheel[TWMAX];
        char RemarksAndEndorsements[RAEMAX];
};

struct OldEntries
{
	char Date[DTMAX];
        char TailNumber[TNMAX];
        char MakeModel[MMMAX];
        char From[FRMAX];
        char To[TOMAX];
        char TotalDur[TDMAX];
        char ActInst[AIMAX];
        char SimInst[SIMAX];
        char Apps[APPSMAX];
        char TypeOfApproaches[TOAMAX];
        char Day[DAYMAX];
        char Night[NIGHTMAX];
        char DayLdgs[DLMAX];
        char NightLdgs[NLMAX];
        char XC[XCMAX];
        char PIC[PICMAX];
        char SIC[SICMAX];
        char Part135[P135MAX];
        char Part121[P121MAX];
        char Mil[MILMAX];
        char DualRec[DRMAX];
        char DualGiv[DGMAX];
        char User1[U1MAX];
        char User2[U2MAX];
        char ASEL[ASELMAX];
        char AMEL[AMELMAX];
        char HighPerf[HPMAX];
        char Retract[RETMAX];
        char Jet[JETMAX];
        char TProp[TPMAX];
        char Sim[SIMMAX];
        char Helo[HELOMAX];
        char Glider[GLIMAX];
        char TailWheel[TWMAX];
};

struct Preferences 
{
	char TailNumber[TNMAX];
        char MakeModel[MMMAX];
        char From[FRMAX];
        char To[TOMAX];
	char TypeOfApproaches[TOAMAX];
};

struct OldEntries *old, *temp;
struct Preferences *pref;

/* Start the function declarations .. There aren't many of these, are there? */

int main(int argc, char *argv[]);
void draw_and_set_up_signals(struct CurrentEntries *curr);
void delete_window( GtkWidget *widget, gpointer data );
gint32 delete_event(GtkWidget *widget, GdkEvent *event, struct CurrentEntries *curr);
void destroy(GtkWidget *widget, gpointer data);
GtkWidget * AddMenu(GtkWidget *menu, gchar *text);
void drawmenu(GtkWidget *box, struct CurrentEntries *curr);
GtkWidget *gtk_xpm_box_new (GtkWidget *parent, gchar *xpm_filename);
GtkWidget * draw_button_bar(GtkWidget *buttonbox, GtkWidget *mainwindow, gchar *path);
void datechanged(GtkWidget *widget, struct CurrentEntries *curr);
void tailchanged(GtkWidget *widget, struct CurrentEntries *data);
void makemodelchanged(GtkWidget *widget, struct CurrentEntries *curr);
void fromchanged(GtkWidget *widget, struct CurrentEntries *curr);
void tochanged(GtkWidget *widget, struct CurrentEntries *curr);
void totaldurchanged(GtkWidget *widget, struct CurrentEntries *curr);
void siminstchanged(GtkWidget *widget, struct CurrentEntries *curr);
void actinstchanged(GtkWidget *widget, struct CurrentEntries *curr);
void appschanged(GtkWidget *widget, struct CurrentEntries *curr);
void typeofapproachchanged(GtkWidget *widget, struct CurrentEntries *curr);
void daychanged(GtkWidget *widget, struct CurrentEntries *curr);
void nightchanged(GtkWidget *widget, struct CurrentEntries *curr);
void dayldgschanged(GtkWidget *widget, struct CurrentEntries *curr);
void nightldgschanged(GtkWidget *widget, struct CurrentEntries *curr);
void xcchanged(GtkWidget *widget, struct CurrentEntries *curr);
void picchanged(GtkWidget *widget, struct CurrentEntries *curr);
void sicchanged(GtkWidget *widget, struct CurrentEntries *curr);
void part135changed(GtkWidget *widget, struct CurrentEntries *curr);
void part121changed(GtkWidget *widget, struct CurrentEntries *curr);
void milchanged(GtkWidget *widget, struct CurrentEntries *curr);
void aselchanged(GtkWidget *widget, struct CurrentEntries *curr);
void amelchanged(GtkWidget *widget, struct CurrentEntries *curr);
void highperfchanged(GtkWidget *widget, struct CurrentEntries *curr);
void retractchanged(GtkWidget *widget, struct CurrentEntries *curr);
void jetchanged(GtkWidget *widget, struct CurrentEntries *curr);
void tpropchanged(GtkWidget *widget, struct CurrentEntries *curr);
void simchanged(GtkWidget *widget, struct CurrentEntries *curr);
void helochanged(GtkWidget *widget, struct CurrentEntries *curr);
void gliderchanged(GtkWidget *widget, struct CurrentEntries *curr);
void tailwheelchanged(GtkWidget *widget, struct CurrentEntries *curr);
void user1changed(GtkWidget *widget, struct CurrentEntries *curr);
void user2changed(GtkWidget *widget, struct CurrentEntries *curr);
void dualrecchanged(GtkWidget *widget, struct CurrentEntries *curr);
void dualgivchanged(GtkWidget *widget, struct CurrentEntries *curr);
void savebutton(GtkWidget *widget, struct CurrentEntries *curr);
void boxchanged(GtkWidget *widget, struct CurrentEntries *curr);
void viewtotals(GtkWidget *widget, struct CurrentEntries *curr);
gint32 newwindowclosed(GtkWidget *widget, GdkEvent *event, gpointer data);
void drawactivity(struct CurrentEntries *curr);
void resetbutton(GtkWidget *widget, struct CurrentEntries *curr);
gint32 hideinfolabel(gpointer *data);
void file_ok_clicked(GtkWidget *widget, struct CurrentEntries *curr);
void prompt_for_file(struct CurrentEntries *curr);
void closeview(GtkWidget *widget, gpointer *data);
void read_old_database(void);
void Usage(void);
void add_entries(void);
void del_entries(void);
void viewlogbook(GtkWidget *widget, struct CurrentEntries *curr);
void closelogbook(GtkWidget *widget, gpointer *data);
void editbuttonclicked(GtkWidget *widget, struct CurrentEntries *curr);
void selectionclicked( GtkWidget *clist, gint32 row, gint column, GdkEventButton *event, gpointer *data);
gint32 parse_rc(struct CurrentEntries *curr);
void closedialog(GtkWidget *widget, gpointer *data);
void change_preferences(GtkWidget *widget, gpointer *data);
void closeprefwindow(GtkWidget *widget, gpointer *data);
void saveprefs(GtkWidget *widget, gpointer *data);
void tailprefchanged(GtkWidget *widget, struct CurrentEntries *data);
void toprefchanged(GtkWidget *widget, struct CurrentEntries *data);
void fromprefchanged(GtkWidget *widget, struct CurrentEntries *data);
void typeprefchanged(GtkWidget *widget, struct CurrentEntries *data);
void makeprefchanged(GtkWidget *widget, struct CurrentEntries *data);
void show_splash_screen(struct CurrentEntries *curr);
void destroysplash(GtkWidget *widget, gpointer *data);
void deleterecord(GtkWidget *widget, struct CurrentEntries *curr);
void medicalinfo(GtkWidget *widget, struct CurrentEntries *curr);
