#include "gplbp.h"

gint32 parse_rc(struct CurrentEntries *curr)
{
	gchar rcfilename[128]; 
	gchar line[256];  /* Let's just hope that no one has an rc file with a line longer than this. */
	FILE *rcfile;
	gchar *pointer;

	snprintf(rcfilename, 128, "%s%s", getenv("HOME"), "/.gplbprc");
	#ifdef DEBUG
		g_print("Trying to open %s.\n", rcfilename);
		fflush(stdout);
	#endif
	
	rcfile = fopen (rcfilename, "r");
	if (rcfile == NULL)
	{
		return 0;
	}
	while (!feof(rcfile))
	{
		memset(line, '\0', 255);
		fgets(line, 255, rcfile);
		if ((pointer = strstr(line, "makemodel=")) != NULL)
		{
			pointer = strchr(line, '=');
			pointer++;
			strncpy(curr->MakeModel, pointer, MMMAX);
		}
		if ((pointer = strstr(line, "from=")) != NULL)
		{
			pointer = strchr(line, '=');
			pointer++;
			strncpy(curr->From, pointer, FRMAX);
		}
		if ((pointer = strstr(line, "to=")) != NULL)
		{
			pointer = strchr(line, '=');
			pointer++;
			strncpy(curr->To, pointer, TOMAX);
		}
		if ((pointer = strstr(line, "typeofapproaches=")) != NULL)
		{
			pointer = strchr(line, '=');
			pointer++;
			strncpy(curr->TypeOfApproaches, pointer, TOAMAX);
		}
		if ((pointer = strstr(line, "tailnumber=")) != NULL)
                {
                        pointer = strchr(line, '=');
                        pointer++;
                        strncpy(curr->TailNumber, pointer, TOAMAX);
                }

	}
	fclose(rcfile);
	return 1;
}
