#include "gplbp.h"



void closelogbook(GtkWidget *widget, gpointer *data)
{
	gtk_widget_destroy(logbookwindow);
	logbookwindow = NULL;
}

void viewlogbook(GtkWidget *widget, struct CurrentEntries *curr)
{
	GtkWidget *table;
	GtkWidget *button;
	GtkWidget *buttonbox;
	GtkTooltips *tooltips;
	gchar number[7];
	gint32 c;
	size_t bytes;
	gchar *titles[7] = { "Entry", "Date", "Tail #", "Make/Model", "From", "To", "Total Duration" };
	struct OldEntries *vars;

	clistrow = -1;

	if (logbookwindow != NULL)
	{
		gtk_widget_destroy(logbookwindow);
		logbookwindow = NULL;
		#ifdef DEBUG
			g_print("Closing LogBook window for rehash.\n");
			fflush(stdout);
		#endif
	}
		
	logbookwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect(GTK_OBJECT(logbookwindow), "delete_event", GTK_SIGNAL_FUNC(closelogbook), curr);
	table = gtk_table_new(2, 1, FALSE);
	buttonbox = gtk_hbox_new(FALSE, 2);

	clist = gtk_clist_new_with_titles(7, titles);
	gtk_signal_connect(GTK_OBJECT(clist), "select_row", GTK_SIGNAL_FUNC(selectionclicked), curr);
	gtk_clist_set_shadow_type(GTK_CLIST(clist), GTK_SHADOW_ETCHED_IN);

	for (c = 0; c < 6; c++)
	{
		gtk_clist_set_column_justification(GTK_CLIST(clist), c, GTK_JUSTIFY_LEFT);
	}

/* Do some file seeking */
	fseek(datafile, 0, SEEK_SET);
	vars = malloc(sizeof(struct OldEntries));
	bytes = fread(vars, sizeof(struct OldEntries), 1, datafile);
	c = 1;
	snprintf(number, 6, "%i", c);

	while (bytes != 0)
	{
		gchar *entry[7] = { number, vars->Date, vars->TailNumber, vars->MakeModel, vars->From, vars->To, vars->TotalDur };
		gtk_clist_append(GTK_CLIST(clist), entry);
		fseek(datafile, -1 * sizeof(struct OldEntries), SEEK_CUR);
		fseek(datafile, sizeof(struct CurrentEntries), SEEK_CUR);
		bytes = fread(vars, sizeof(struct OldEntries), 1, datafile);
		c++;
		snprintf(number, 6, "%i", c);
	} 

	gtk_clist_set_column_width(GTK_CLIST(clist), 0, 30);
	gtk_clist_set_column_width(GTK_CLIST(clist), 1, 60);
	gtk_clist_set_column_width(GTK_CLIST(clist), 2, 50);
	gtk_clist_set_column_width(GTK_CLIST(clist), 3, 100);
        gtk_clist_set_column_width(GTK_CLIST(clist), 4, 100);
        gtk_clist_set_column_width(GTK_CLIST(clist), 5, 100);
	gtk_clist_set_column_width(GTK_CLIST(clist), 6, 40);
	gtk_widget_set_usize(clist, 590, 300);

	tooltips = gtk_tooltips_new();
	button = gtk_button_new_with_label("Edit");
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(editbuttonclicked), curr);
	gtk_tooltips_set_tip(tooltips, button, "Edit the selected logbook entry", NULL);
	gtk_widget_show(button);

	tooltips = gtk_tooltips_new();	
	button = gtk_button_new_with_label("Delete");
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	gtk_tooltips_set_tip(tooltips, button, "Delete the selected logbook entry", NULL);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(deleterecord), curr);
	gtk_widget_show(button);

	tooltips = gtk_tooltips_new();
	button = gtk_button_new_with_label("Close");
	gtk_box_pack_start(GTK_BOX(buttonbox), button, FALSE, FALSE, 0);
	gtk_tooltips_set_tip(tooltips, button, "Close the current window", NULL);
	gtk_widget_show(button);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(closelogbook), NULL);

	gtk_table_attach(GTK_TABLE(table), clist, 0, 1, 0, 1, 0, 0, 0, 0);
	gtk_table_attach(GTK_TABLE(table), buttonbox, 0, 1, 1, 2, 0, 0, 0, 0);

	gtk_container_add(GTK_CONTAINER(logbookwindow), table);
	gtk_container_border_width(GTK_CONTAINER(logbookwindow), 5);
	gtk_widget_show(table);
	gtk_widget_show(buttonbox);
	gtk_widget_show(clist);
	gtk_widget_show(logbookwindow);

	free(vars);
}	

void selectionclicked( GtkWidget *clist, gint32 row, gint column, GdkEventButton *event, gpointer *data)
{
	clistrow = row;
}

void editbuttonclicked(GtkWidget *widget, struct CurrentEntries *curr)
{
	GtkWidget *label;	
	GtkWidget *button;	
	GtkWidget *vbox;

	gchar *data;

	if (clistrow > -1)
	{
		clistrow1 = clistrow;
		editing = 1;
		gtk_clist_get_text(GTK_CLIST(clist), clistrow, 0, &data);
		#ifdef DEBUG
			g_print("You just clicked on row number %i.\n", clistrow + 1);	
			fflush(stdout);
		#endif
		fseek(datafile, sizeof (struct CurrentEntries) * (1 + clistrow), SEEK_SET);
		fseek(datafile, sizeof (struct CurrentEntries) * -1, SEEK_CUR);
		fread(curr, sizeof(struct CurrentEntries), 1, datafile);

		gtk_widget_destroy(activitytable);
       	 	drawactivity(curr);
        	saved = 0;
	
		gtk_widget_destroy(logbookwindow);
		logbookwindow = NULL;
	}
	else
	{	
		dialogwindow = gtk_window_new(GTK_WINDOW_DIALOG);
		gtk_window_position(GTK_WINDOW(dialogwindow), GTK_WIN_POS_MOUSE);
		vbox = gtk_vbox_new(FALSE, 0);

		label = gtk_label_new("You have not selected\nan item for editing.");
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);

		button = gtk_button_new_with_label("OK");
		gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(closedialog), NULL);
		gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);

		gtk_container_add(GTK_CONTAINER(dialogwindow), vbox);
		gtk_container_border_width(GTK_CONTAINER(dialogwindow), 5);
		gtk_widget_show(label);
		gtk_widget_show(button);
		gtk_widget_show(vbox);
		gtk_widget_show(dialogwindow);
	}
}

void closedialog(GtkWidget *widget, gpointer *data)
{
	gtk_widget_destroy(dialogwindow);
	dialogwindow = NULL;
}
