#include "gplbp.h"

void viewtotals(GtkWidget *widget, struct CurrentEntries *curr)
{

	GtkWidget *newtable;
	GtkWidget *closebutton;
	GtkWidget *label;
	GtkWidget *entry;
	GtkTooltips *tooltips;
	gchar *totals;
	gfloat mygfloat = 0.0;

	read_old_database();

/* Unmap the newwindow if it's non-null, this way the user won't get 60 windows if [s]he clicks on
 * the view logbook button 60 times. 
 */
	if (newwindow != NULL)
	{
		#ifdef DEBUG
			g_print("Destroying newwindow for a redraw.\n");
			fflush(stdout);
		#endif
		gtk_widget_destroy(newwindow);
	}

	totals = malloc(sizeof(gchar) * 20);

	#ifdef DEBUG
		g_print("Just allocated %i bytes of memory.\n", sizeof(gchar) * 20);
		fflush(stdout);
	#endif
		
	if (totals == NULL)
	{
		g_print ("Malloc failed.  Out of memory?\n");
		fflush(stdout);
		exit(255);
	}

	newwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(newwindow), "Totals");
	gtk_signal_connect(GTK_OBJECT(newwindow), "delete_event", GTK_SIGNAL_FUNC(newwindowclosed), NULL);
	
	newtable = gtk_table_new(30, 2, FALSE);

	label = gtk_label_new("Total Flight:");
	gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 0, 1, 0, 0, 0, 0);
	entry = gtk_entry_new();
	mygfloat = atof(old->TotalDur);
	snprintf(totals, 9, "%.2f", mygfloat);
	gtk_entry_set_text(GTK_ENTRY(entry), totals);
	gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 0, 1, 0, 0, 0, 0);
	gtk_widget_set_usize(entry, 50, 20);
	gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
	gtk_widget_show(entry);
	gtk_widget_show(label);	

	label = gtk_label_new("Total Insturment:");
	gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 1, 2, 0, 0, 0, 0);
	entry = gtk_entry_new();
	mygfloat = atof( old->ActInst);
	snprintf(totals, 9, "%.2f", mygfloat);
	gtk_entry_set_text(GTK_ENTRY(entry), totals);
	gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 1, 2, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
	gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Simulated Insturment:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 2, 3, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->SimInst);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 2, 3, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Number of Approaches:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 3, 4, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Apps);
        snprintf(totals, 9, "%.0f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 3, 4, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Day Flight:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 4, 5, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Day);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 4, 5, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Night Flight:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 5, 6, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Night);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 5, 6, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Day Landings:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 6, 7, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->DayLdgs);
        snprintf(totals, 9, "%.0f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 6, 7, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Night Landings:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 7, 8, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->NightLdgs);
        snprintf(totals, 9, "%.0f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 7, 8, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Pilot in Command:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 8, 9, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->PIC);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 8, 9, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Second in Command:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 9, 10, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat =  atof(old->SIC);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 9, 10, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Part 135:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 10, 11, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Part135);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 10, 11, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Part 121:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 11, 12, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Part121);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 11, 12, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Military:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 12, 13, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Mil);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 12, 13, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Dual Recieved:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 13, 14, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat =  atof(old->DualRec);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 13, 14, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Dual Given:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 14, 15, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->DualGiv);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 14, 15, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Single Engine Land:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 15, 16, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->ASEL);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 15, 16, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Multi Engine Land:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 16, 17, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->AMEL);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 16, 17, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total High Performance:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 18, 19, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->HighPerf);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 18, 19, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Retractable Gear:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 19, 20, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat =  atof(old->Retract);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 19, 20, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

        label = gtk_label_new("Total Jet:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 20, 21, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Jet);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 20, 21, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Turbo Prop:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 21, 22, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->TProp);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 21, 22, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Simulator:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 22, 23, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat =  atof(old->Sim);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 22, 23, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Helocopter:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 23, 24, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat =  atof(old->Helo);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 23, 24, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Glider:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 24, 25, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->Glider);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 24, 25, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Tail Wheel:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 25, 26, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->TailWheel);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 25, 26, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	label = gtk_label_new("Total Cross Country:");
        gtk_table_attach(GTK_TABLE(newtable), label, 0, 1, 26, 27, 0, 0, 0, 0);
        entry = gtk_entry_new();
        mygfloat = atof(old->XC);
        snprintf(totals, 9, "%.2f", mygfloat);
        gtk_entry_set_text(GTK_ENTRY(entry), totals);
        gtk_table_attach(GTK_TABLE(newtable), entry, 1, 2, 26, 27, 0, 0, 0, 0);
        gtk_widget_set_usize(entry, 50, 20);
        gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
        gtk_widget_show(entry);
        gtk_widget_show(label);

	tooltips = gtk_tooltips_new();
	closebutton = gtk_button_new_with_label("Close");
	gtk_table_attach(GTK_TABLE(newtable), closebutton, 0, 2, 27, 28, 0, 0, 0, 0);
	gtk_tooltips_set_tip(tooltips, closebutton, "Close the current window", NULL);
	gtk_widget_show(closebutton);
	gtk_signal_connect(GTK_OBJECT(closebutton), "clicked", GTK_SIGNAL_FUNC(closeview), NULL);

	gtk_container_add(GTK_CONTAINER(newwindow), newtable);
	gtk_container_border_width(GTK_CONTAINER(newwindow), 5);

	free(totals);
	#ifdef DEBUG
                g_print("Just freed %i bytes of memory.\n", sizeof(gchar) * 20);
                fflush(stdout);
        #endif

	gtk_widget_show(newtable);
	gtk_widget_show(newwindow);
}

void closeview(GtkWidget *widget, gpointer *data)
{
	gtk_widget_destroy(newwindow);
	newwindow = NULL;

	#ifdef DEBUG
		g_print("Just closed the view totals window.\n");
		fflush(stdout);
	#endif
}
